## libhdf4 4.2.16

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4 C)

if (POLICY CMP0074)
  # find_package() uses <PackageName>_ROOT variables.
  cmake_policy (SET CMP0074 NEW)
endif ()

if (POLICY CMP0083)
  # To control generation of Position Independent Executable (PIE) or not,
  # some flags are required at link time.
  cmake_policy (SET CMP0083 NEW)
endif ()

# Avoid warning about DOWNLOAD_EXTRACT_TIMESTAMP in CMake 3.24:
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
    cmake_policy(SET CMP0135 NEW)
endif()

#-----------------------------------------------------------------------------
# Instructions for use : Normal Build
#
# For standard build of HDF4 libraries,tests and tools.
# Run cmake using the HDF4 source tree to generate a build tree.
# Enable/Disable options according to requirements and
# set CMAKE_INSTALL_PREFIX to the required install path.
# Make install can be used to install all components for system-wide use.
#
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
    message (FATAL_ERROR "\nERROR! ${PROJECT_NAME} DOES NOT SUPPORT IN SOURCE BUILDS!\n"
      "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}"
      " == CMAKE_CURRENT_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}\n"
      "NEXT STEPS:\n"
      "(1) Delete the CMakeCache.txt file and the CMakeFiles/ directory\n"
      "     under the source directory for ${PROJECT_NAME}, otherwise you\n"
      "     will not be able to configure ${PROJECT_NAME} correctly!\n"
      "      * For example, on linux machines do:\n"
      "        $ rm -r CMakeCache.txt CMakeFiles/\n"
      "(2) Create a different directory and configure ${PROJECT_NAME} in that directory.\n"
      "      * For example, on linux machines do:\n"
      "        $ mkdir MY_BUILD\n"
      "        $ cd MY_BUILD\n"
      "        $ cmake [OPTIONS] ..\n"
      )
endif ()

# CMake version 3.14 added option --ignore-eol to compare files
#     cmake -E compare_files --ignore-eol file1 file2
set (CMAKE_IGNORE_EOL "--ignore-eol")
if (CMAKE_VERSION VERSION_LESS "3.14.0")
  set (CMAKE_IGNORE_EOL "")
  if (WIN32)
    message (FATAL_ERROR "Windows builds require a minimum of CMake 3.14")
  endif()
endif ()

#-----------------------------------------------------------------------------
# Instructions for use : Sub-Project Build
#
# To include HDF4 as a sub-project within another project.
# Set HDF4_EXTERNALLY_CONFIGURED to 1 in the parent project and
# supply values for the following variables...
#
# HDF4_EXPORTED_TARGETS :
#   Set this to the name of the targets variable which controls exports
#   If unset (because parent project does not support/use the
#   install (EXPORT target...) syntax), then targets are not configured
#   for export during install.
#
# HDF4_LIB_DEPENDENCIES :
#   If the build of HDF4 libs is being customized, then rules for the
#   dependencies of the HDF4 libs may be 'incomplete', add additional
#   dependencies to this variable so that external projects pick them up
#
#option (HDF4_EXTERNAL_LIB_PREFIX "Use prefix for custom library naming." "")
set (HDF4_EXTERNAL_LIB_PREFIX "" CACHE STRING "Use prefix for custom library naming.")
mark_as_advanced (HDF4_EXTERNAL_LIB_PREFIX)
# HDF4_EXTERNAL_LIB_PREFIX :
#   If the parent project needs to install hdf libraries, but avoid
#   name conflicts with system versions, then a prefix may be added
#   to ensure that the correct versions configured are used.
#
# HDF4_INSTALL_BIN_DIR, HDF4_INSTALL_LIB_DIR, HDF4_INSTALL_INCLUDE_DIR, HDF4_INSTALL_DATA_DIR :
#   Customize the 'bin', 'lib', 'include', and 'share' installation directories.
#
# HDF4_INSTALL_NO_DEVELOPMENT :
#   Set to true to skip installation of headers and CMake package files.
#
# Consider this example, it builds its own zlib
# library and tells HDF4 to add it as a dependency - this ensures that
# any project making use of this build of HDF4 will use the correct zlib
#
#   # Tell hdf4 that we are manually overriding certain settings
#   set (HDF4_EXTERNALLY_CONFIGURED 1)
#   # Avoid duplicating names of installed libraries
#   set (HDF4_EXTERNAL_LIB_PREFIX "prj")
#   # Targets linking to the HDF4 libs need to know their names
#   # if they are changed in the sub project, they should be here too
#   set (HDF4_LIB_NAME "prjhdf4")
#   set (HDF4_MF_LIB_NAME "prjhdf4_mf")
#   set (HDF4_LIBRARY "${HDF4_LIB_NAME};${HDF4_MF_LIB_NAME}")
#   # Export configuration to this export variable
#   set (HDF4_EXPORTED_TARGETS "project-targets")
#
#   # Setup all necessary overrides for zlib so that HDF4 uses our
#   # internally compiled zlib rather than any other version
#   if (HDF4_ENABLE_Z_LIB_SUPPORT)
#    # We must tell the main HDF4 library that it depends on our zlib
#     set (HDF4_LIB_DEPENDENCIES prjzlib)
#     # Override the zlib header file
#     if (PRJ_USE_SYSTEM_ZLIB)
#       set (H4_ZLIB_HEADER "zlib.h")
#     else ()
#      set (H4_ZLIB_HEADER "prj_zlib.h")
#       # Set vars that FindZlib would have set if used in sub project
#       set (ZLIB_INCLUDE_DIRS "${PRJ_ZLIB_INCLUDE_DIRS}")
#       set (ZLIB_LIBRARIES prjzlib)
#     endif ()
#  endif ()
#
#   # Add the sub project
#   add_subdirectory (Utilities/hdf4.2.5)
#   # Add the HDF4 dirs to our include path
#   set (HDF4_INCLUDE_DIR
#       ${PROJECT_SOURCE_DIR}/Utilities/hdf4.2.5/hdf/src
#       ${PROJECT_BINARY_DIR}/Utilities/hdf4.2.5
#       ${PROJECT_SOURCE_DIR}/Utilities/hdf4.2.5/mfhdf/libsrc
#   )
#
#-----------------------------------------------------------------------------
string (TIMESTAMP CONFIG_DATE "%Y-%m-%d")

#-----------------------------------------------------------------------------
# Allow Visual Studio solution directories
#-----------------------------------------------------------------------------
# Provide a way for Visual Studio Express users to turn OFF the new FOLDER
# organization feature. Default to ON for non-Express users. Express users must
# explicitly turn off this option to build HDF4 in the Express IDE...
#
option (HDF4_USE_FOLDERS "Enable folder grouping of projects in IDEs." ON)
mark_as_advanced (HDF4_USE_FOLDERS)
if (HDF4_USE_FOLDERS)
  set_property (GLOBAL PROPERTY USE_FOLDERS ON)
endif ()
option (HDF4_NO_PACKAGES "CPACK - Disable packaging" OFF)
mark_as_advanced (HDF4_NO_PACKAGES)

#-----------------------------------------------------------------------------
# Set the core names of all the libraries
#-----------------------------------------------------------------------------
set (HDF4_SRC_LIB_CORENAME          "hdf")
set (HDF4_SRC_FCSTUB_LIB_CORENAME   "hdf_fcstub")
set (HDF4_SRC_FORTRAN_LIB_CORENAME  "hdf_fortran")
set (HDF4_MF_LIB_CORENAME           "mfhdf")
set (HDF4_MF_XDR_LIB_CORENAME       "xdr")
set (HDF4_HDF_TEST_LIB_CORENAME     "hdf_test")
set (HDF4_HDF_TEST_FCSTUB_LIB_CORENAME     "hdf_test_fcstub")
set (HDF4_MF_FCSTUB_LIB_CORENAME    "mfhdf_fcstub")
set (HDF4_MF_FORTRAN_LIB_CORENAME   "mfhdf_fortran")
set (HDF4_MF_TEST_LIB_CORENAME      "mf_test")
set (HDF4_TOOLS_LIB_CORENAME        "h4tools")
set (HDF4_JAVA_JNI_LIB_CORENAME     "hdf_java")
set (HDF4_JAVA_HDF_LIB_CORENAME     "jarhdf")
set (HDF4_JAVA_TEST_LIB_CORENAME    "jartest4")

#-----------------------------------------------------------------------------
# Set the true names of all the libraries if customized by external project
#-----------------------------------------------------------------------------
set (HDF4_SRC_LIB_NAME          "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_SRC_LIB_CORENAME}")
set (HDF4_SRC_FCSTUB_LIB_NAME   "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_SRC_FCSTUB_LIB_CORENAME}")
set (HDF4_SRC_FORTRAN_LIB_NAME  "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_SRC_FORTRAN_LIB_CORENAME}")
set (HDF4_MF_LIB_NAME           "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_MF_LIB_CORENAME}")
set (HDF4_MF_XDR_LIB_NAME       "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_MF_XDR_LIB_CORENAME}")
set (HDF4_HDF_TEST_LIB_NAME     "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_HDF_TEST_LIB_CORENAME}")
set (HDF4_HDF_TEST_FCSTUB_LIB_NAME     "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_HDF_TEST_FCSTUB_LIB_CORENAME}")
set (HDF4_MF_FCSTUB_LIB_NAME    "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_MF_FCSTUB_LIB_CORENAME}")
set (HDF4_MF_FORTRAN_LIB_NAME   "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_MF_FORTRAN_LIB_CORENAME}")
set (HDF4_MF_TEST_LIB_NAME      "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_MF_TEST_LIB_CORENAME}")
set (HDF4_TOOLS_LIB_NAME        "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_TOOLS_LIB_CORENAME}")
set (HDF4_JAVA_JNI_LIB_NAME     "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_JAVA_JNI_LIB_CORENAME}")
set (HDF4_JAVA_HDF_LIB_NAME     "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_JAVA_HDF_LIB_CORENAME}")
set (HDF4_JAVA_TEST_LIB_NAME    "${HDF4_EXTERNAL_LIB_PREFIX}${HDF4_JAVA_TEST_LIB_CORENAME}")

#-----------------------------------------------------------------------------
# Set the target names of all the libraries
#-----------------------------------------------------------------------------
set (HDF4_SRC_LIB_TARGET          "${HDF4_SRC_LIB_CORENAME}-static")
set (HDF4_SRC_FCSTUB_LIB_TARGET   "${HDF4_SRC_FCSTUB_LIB_CORENAME}-static")
set (HDF4_SRC_FORTRAN_LIB_TARGET  "${HDF4_SRC_FORTRAN_LIB_CORENAME}-static")
set (HDF4_MF_LIB_TARGET           "${HDF4_MF_LIB_CORENAME}-static")
set (HDF4_MF_XDR_LIB_TARGET       "${HDF4_MF_XDR_LIB_CORENAME}-static")
set (HDF4_HDF_TEST_LIB_TARGET     "${HDF4_HDF_TEST_LIB_CORENAME}-static")
set (HDF4_HDF_TEST_FCSTUB_LIB_TARGET     "${HDF4_HDF_TEST_FCSTUB_LIB_CORENAME}-static")
set (HDF4_MF_FCSTUB_LIB_TARGET    "${HDF4_MF_FCSTUB_LIB_CORENAME}-static")
set (HDF4_MF_FORTRAN_LIB_TARGET   "${HDF4_MF_FORTRAN_LIB_CORENAME}-static")
set (HDF4_MF_TEST_LIB_TARGET      "${HDF4_MF_TEST_LIB_CORENAME}-static")
set (HDF4_TOOLS_LIB_TARGET        "${HDF4_TOOLS_LIB_CORENAME}-static")
set (HDF4_JAVA_JNI_LIB_TARGET     "${HDF4_JAVA_JNI_LIB_CORENAME}")
set (HDF4_JAVA_HDF_LIB_TARGET     "${HDF4_JAVA_HDF_LIB_CORENAME}")
set (HDF4_JAVA_TEST_LIB_TARGET    "${HDF4_JAVA_TEST_LIB_CORENAME}")
set (HDF4_SRC_LIBSH_TARGET          "${HDF4_SRC_LIB_CORENAME}-shared")
set (HDF4_SRC_FCSTUB_LIBSH_TARGET   "${HDF4_SRC_FCSTUB_LIB_CORENAME}-shared")
set (HDF4_SRC_FORTRAN_LIBSH_TARGET  "${HDF4_SRC_FORTRAN_LIB_CORENAME}-shared")
set (HDF4_MF_LIBSH_TARGET           "${HDF4_MF_LIB_CORENAME}-shared")
set (HDF4_MF_XDR_LIBSH_TARGET       "${HDF4_MF_XDR_LIB_CORENAME}-shared")
set (HDF4_MF_FCSTUB_LIBSH_TARGET    "${HDF4_MF_FCSTUB_LIB_CORENAME}-shared")
set (HDF4_MF_FORTRAN_LIBSH_TARGET   "${HDF4_MF_FORTRAN_LIB_CORENAME}-shared")
set (HDF4_TOOLS_LIBSH_TARGET        "${HDF4_TOOLS_LIB_CORENAME}-shared")

#-----------------------------------------------------------------------------
# Define some CMake variables for use later in the project
#-----------------------------------------------------------------------------
set (HDF_RESOURCES_DIR        ${HDF4_SOURCE_DIR}/config/cmake)
set (HDF4_HDFSOURCE_DIR       ${HDF4_SOURCE_DIR}/hdf/src)
set (HDF4_HDF_TESTSOURCE_DIR  ${HDF4_SOURCE_DIR}/hdf/test)
set (HDF4_MFHDFSOURCE_DIR     ${HDF4_SOURCE_DIR}/mfhdf/libsrc)
set (HDF4_MFHDF_TEST_DIR      ${HDF4_SOURCE_DIR}/mfhdf/test)
set (HDF4_MFHDF_UTIL_DIR      ${HDF4_SOURCE_DIR}/mfhdf/util)
set (HDF4_MFHDF_FORTRAN_DIR   ${HDF4_SOURCE_DIR}/mfhdf/fortran)
set (HDF4_MFHDF_XDR_DIR       ${HDF4_SOURCE_DIR}/mfhdf/xdr)
set (HDF4_JAVA_JNI_SRC_DIR         ${HDF4_SOURCE_DIR}/java/src/jni)
set (HDF4_JAVA_HDF_SRC_DIR         ${HDF4_SOURCE_DIR}/java/src/hdf)
set (HDF4_JAVA_TEST_SRC_DIR        ${HDF4_SOURCE_DIR}/java/test)
set (HDF4_JAVA_LIB_DIR             ${HDF4_SOURCE_DIR}/java/lib)
set (HDF4_JAVA_LOGGING_JAR         ${HDF4_SOURCE_DIR}/java/lib/slf4j-api-1.7.33.jar)
set (HDF4_JAVA_LOGGING_NOP_JAR     ${HDF4_SOURCE_DIR}/java/lib/ext/slf4j-nop-1.7.33.jar)
set (HDF4_JAVA_LOGGING_SIMPLE_JAR  ${HDF4_SOURCE_DIR}/java/lib/ext/slf4j-simple-1.7.33.jar)

set (CMAKE_MODULE_PATH ${HDF_RESOURCES_DIR} ${CMAKE_MODULE_PATH})

#-----------------------------------------------------------------------------
# parse the full version number from hfile.h and include in H4_VERS_INFO

=== Makefile ===
# Top-level distributed Makefile 			       -*- makefile -*-

# Copyright by The HDF Group.
# Copyright by the Board of Trustees of the University of Illinois.
# All rights reserved.
#
# This file is part of HDF.  The full HDF copyright notice, including
# terms governing use, modification, and redistribution, is contained in
# the COPYING file, which can be found at the root of the source code
# distribution tree, or in https://support.hdfgroup.org/ftp/HDF/releases/.
# If you do not have access to either file, you may request a copy from
# help@hdfgroup.org.


# This Makefile is a stub (copied from Makefile.dist) which will run
# configure and then invoke the same target in the new Makefile created
# by configure.

# Uncomment this variable if your make(1) doesn't set it automatically.
#
#MAKE=make


SHELL=/bin/sh

all lib progs check test _test install uninstall dep depend: _config
	$(MAKE) $@

clean mostlyclean distclean maintainer-clean TAGS: _config
	$(MAKE) $@

_config:
	sh configure

.PHONY: all lib progs test install uninstall dep depend clean mostlyclean     \
	distclean maintainer-clean _config

=== java/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_JAVA C Java)

set (CMAKE_MODULE_PATH "${HDF_RESOURCES_DIR}")
find_package (Java)
#-----------------------------------------------------------------------------
# Include some macros for reusable code
#-----------------------------------------------------------------------------
include (${HDF_RESOURCES_DIR}/UseJava.cmake)

message (STATUS "JAVA: JAVA_HOME=$ENV{JAVA_HOME} JAVA_ROOT=$ENV{JAVA_ROOT}")
find_package (JNI)
message (STATUS "JNI_LIBRARIES=${JNI_LIBRARIES}")
message (STATUS "JNI_INCLUDE_DIRS=${JNI_INCLUDE_DIRS}")


if (WIN32)
  set (HDF_JRE_DIRECTORY "C:/Program Files/Java/jre")
else ()
  set (HDF_JRE_DIRECTORY "/usr/lib/jvm/jre")
endif ()

#-----------------------------------------------------------------------------
# Include the main src and config directories
#-----------------------------------------------------------------------------
set (HDF4_JAVA_INCLUDE_DIRECTORIES
    ${JNI_INCLUDE_DIRS}
    ${HDF4_JAVA_JNI_SRC_DIR}
    ${JAVA_INCLUDE_PATH}
    ${JAVA_INCLUDE_PATH2}
)
set_directory_properties(PROPERTIES INCLUDE_DIRECTORIES "${HDF4_JAVA_INCLUDE_DIRECTORIES}")

set (CMAKE_JAVA_INCLUDE_PATH "")

#-----------------------------------------------------------------------------
# Traverse source subdirectory
#-----------------------------------------------------------------------------
add_subdirectory (src)

#-----------------------------------------------------------------------------
# Build the Java Examples
#-----------------------------------------------------------------------------
if (HDF4_BUILD_EXAMPLES)
  add_subdirectory (examples)
endif ()

#-----------------------------------------------------------------------------
# Testing
#-----------------------------------------------------------------------------
if (BUILD_TESTING)
  add_subdirectory (test)
endif ()

#-----------------------------------------------------------------------------
# Add Required Jar(s)
#-----------------------------------------------------------------------------
install (
    FILES
        ${HDF4_JAVA_LOGGING_JAR}
        ${HDF4_JAVA_LOGGING_NOP_JAR}
        ${HDF4_JAVA_LOGGING_SIMPLE_JAR}
    DESTINATION ${HDF4_INSTALL_JAR_DIR}
    COMPONENT libraries
)

#-----------------------------------------------------------------------------
# Option to include jre
#-----------------------------------------------------------------------------
option (HDF4_JAVA_PACK_JRE  "Package a JRE installer directory" OFF)
if (HDF4_JAVA_PACK_JRE)
  install (
      DIRECTORY ${HDF_JRE_DIRECTORY}
      DESTINATION ${HDF4_INSTALL_BIN_DIR}
      USE_SOURCE_PERMISSIONS
  )
endif ()

=== mfhdf/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_MFHDF)

#-----------------------------------------------------------------------------
# Option to build HDF4 Tools
#-----------------------------------------------------------------------------
if (HDF4_BUILD_TOOLS)
  set (NCGEN_UTILITY 0)
  add_subdirectory (dumper)
  add_subdirectory (hdfimport)
  add_subdirectory (hdiff)
  add_subdirectory (hrepack)
  if (HDF4_BUILD_NETCDF_TOOLS)
    set (NCGEN_UTILITY 1)
    add_subdirectory (ncgen)
    add_subdirectory (ncdump)
  endif ()
  if (BUILD_TESTING)
    add_subdirectory (nctest)
  endif ( )
endif ()

=== hdf/examples/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_HDF_EXAMPLES C)

#-----------------------------------------------------------------------------
# Define Sources
#-----------------------------------------------------------------------------
set (examples
    VD_create_vdatas
    VD_write_mixed_vdata
    VD_write_mixed_vdata_struct
    VD_write_to_vdata
    VD_read_from_vdata
    VD_read_mixed_vdata
    VD_set_get_vdata_attr
    VD_create_onefield_vdatas
    VD_get_vdata_info
    VD_locate_vdata
    VG_create_vgroup
#    VG_add_sds_to_vgroup
    VG_insert_vdatas_to_vgroup
    VG_set_get_vgroup_attr
    VG_vgroup_contents
    VG_get_vgroup_info
    GR_create_and_write_image
    GR_modify_image
    GR_set_attribute
    GR_get_attribute
    GR_write_chunks
    GR_write_palette
    GR_image_info
    GR_read_chunks
    GR_read_image
    AN_create_annotation
    AN_get_annotation_info
    AN_read_annotation
)

foreach (example ${examples})
  add_executable (hdf_${example} ${HDF4_HDF_EXAMPLES_SOURCE_DIR}/${example}.c)
  if (NOT BUILD_SHARED_LIBS)
    TARGET_C_PROPERTIES (hdf_${example} STATIC)
    target_link_libraries (hdf_${example} PRIVATE ${HDF4_SRC_LIB_TARGET})
  else ()
    TARGET_C_PROPERTIES (hdf_${example} SHARED)
    target_link_libraries (hdf_${example} PRIVATE ${HDF4_SRC_LIBSH_TARGET})
  endif ()
endforeach ()

add_executable (hdf_VG_add_sds_to_vgroup ${HDF4_HDF_EXAMPLES_SOURCE_DIR}/VG_add_sds_to_vgroup.c)
if (NOT BUILD_SHARED_LIBS)
  TARGET_C_PROPERTIES (hdf_VG_add_sds_to_vgroup STATIC)
  target_link_libraries (hdf_VG_add_sds_to_vgroup PRIVATE ${HDF4_MF_LIB_TARGET})
else ()
  TARGET_C_PROPERTIES (hdf_VG_add_sds_to_vgroup SHARED)
  target_link_libraries (hdf_VG_add_sds_to_vgroup PRIVATE ${HDF4_MF_LIBSH_TARGET})
endif ()

if (BUILD_TESTING)
  include (CMakeTests.cmake)
endif ()

=== hdf/test/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_HDF_TEST C)

LINK_DIRECTORIES (
    ${HDF4_HDF_BINARY_DIR}
    ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
)

set (testhdf_SRCS
    ${HDF4_HDF_TEST_SOURCE_DIR}/testhdf.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/an.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/anfile.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/bitio.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/blocks.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/chunks.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/comp.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/conv.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/extelt.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/file.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/file1.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/litend.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/macros.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/man.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/mgr.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/nbit.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/rig.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/sdmms.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/sdnmms.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/sdstr.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/slab.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tattdatainfo.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tbv.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tdatainfo.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tdfr8.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tdupimgs.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tmgrattr.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tmgrcomp.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tree.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tszip.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tusejpegfuncs.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tutils.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tvattr.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tvnameclass.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tvset.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/tvsfpack.c
    ${HDF4_HDF_TEST_SOURCE_DIR}/vers.c
  )

#-- Adding test for testhdf
add_executable (testhdf ${testhdf_SRCS})
target_include_directories(testhdf PRIVATE "${HDF4_HDF_BINARY_DIR};${HDF4_HDFSOURCE_DIR}")
if (NOT BUILD_SHARED_LIBS)
  TARGET_C_PROPERTIES (testhdf STATIC)
  target_link_libraries (testhdf PRIVATE ${HDF4_SRC_LIB_TARGET} ${LINK_COMP_LIBS})
else ()
  TARGET_C_PROPERTIES (testhdf SHARED)
  target_link_libraries (testhdf PRIVATE ${HDF4_SRC_LIBSH_TARGET} ${LINK_COMP_LIBS})
endif ()
set_target_properties (testhdf PROPERTIES FOLDER test)

#-- Adding test for buffer
if (NOT WIN32)
  add_executable (buffer ${HDF4_HDF_TEST_SOURCE_DIR}/buffer.c)
  target_include_directories(buffer PRIVATE "${HDF4_HDF_BINARY_DIR};${HDF4_HDFSOURCE_DIR}")
  if (NOT BUILD_SHARED_LIBS)
    TARGET_C_PROPERTIES (buffer STATIC)
    target_link_libraries (buffer PRIVATE ${HDF4_SRC_LIB_TARGET})
  else ()
    TARGET_C_PROPERTIES (buffer SHARED)
    target_link_libraries (buffer PRIVATE ${HDF4_SRC_LIBSH_TARGET})
  endif ()
  set_target_properties (buffer PROPERTIES FOLDER test)
endif ()

include (CMakeTests.cmake)

=== java/examples/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_JAVA_Examples Java)

set (CMAKE_VERBOSE_MAKEFILE 1)

INCLUDE_DIRECTORIES (
    ${HDF4_JAVA_JNI_BINARY_DIR}
    ${HDF4_JAVA_HDF_LIB_DIR}
)

set (HDFJNI_EXAMPLES
    HDF4FileCreate
    HDF4GroupCreate
    HDF4DatasetCreate
    VDWriteToVdata
    VDReadFromVdata
)

if (WIN32 OR MINGW)
  set (CMAKE_JAVA_INCLUDE_FLAG_SEP ";")
else ()
  set (CMAKE_JAVA_INCLUDE_FLAG_SEP ":")
endif ()

set (CMAKE_JAVA_INCLUDE_PATH "${HDF4_JAVA_JARS}")

set (CMAKE_JAVA_CLASSPATH ".")
foreach (CMAKE_INCLUDE_PATH ${CMAKE_JAVA_INCLUDE_PATH})
  set (CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${CMAKE_INCLUDE_PATH}")
endforeach ()

foreach (HCP_JAR ${CMAKE_JAVA_INCLUDE_PATH})
  get_filename_component (_HCP_FILE ${HCP_JAR} NAME)
  set (HDFJNI_CLASSJARS "${_HCP_FILE} ${HDFJNI_CLASSJARS}")
endforeach ()

foreach (example ${HDFJNI_EXAMPLES})
  file (WRITE ${HDF4_JAVA_Examples_BINARY_DIR}/${example}_Manifest.txt
  "Main-Class: examples.${example}
"
  )
  add_jar (${example} MANIFEST ${HDF4_JAVA_Examples_BINARY_DIR}/${example}_Manifest.txt ${example}.java)
  get_target_property (${example}_JAR_FILE ${example} JAR_FILE)
#  install_jar (${example} ${HJAVA_INSTALL_DATA_DIR}/examples examples)
  get_target_property (${example}_CLASSPATH ${example} CLASSDIR)
  add_dependencies (${example} ${HDF4_JAVA_HDF_LIB_TARGET})
  set_target_properties (${example} PROPERTIES FOLDER examples/java)
endforeach ()

set (CMAKE_JAVA_INCLUDE_PATH "${HDF4_JAVA_JARS};${HDF4_JAVA_LOGGING_JAR};${HDF4_JAVA_LOGGING_SIMPLE_JAR}")

set (CMAKE_JAVA_CLASSPATH ".")
foreach (HDFJAVA_JAR ${CMAKE_JAVA_INCLUDE_PATH})
  set (CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${HDFJAVA_JAR}")
endforeach ()

if (BUILD_TESTING)
  get_property (target_name TARGET ${HDF4_JAVA_JNI_LIB_TARGET} PROPERTY OUTPUT_NAME)
  set (CMD_ARGS "-Dhdf.hdflib.HDFLibrary.loadLibraryName=${target_name}$<$<CONFIG:Debug>:${CMAKE_DEBUG_POSTFIX}>;")
  macro (ADD_H4_TEST resultfile resultcode)
    add_test (
        NAME JAVAEX-${resultfile}
        COMMAND "${CMAKE_COMMAND}"
            -D "TEST_TESTER=${CMAKE_Java_RUNTIME};${CMAKE_Java_RUNTIME_FLAGS}"
            -D "TEST_PROGRAM=examples.${resultfile}"
            -D "TEST_ARGS:STRING=${CMD_ARGS}${ARGN}"
            -D "TEST_CLASSPATH:STRING=${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${${resultfile}_JAR_FILE}"
            -D "TEST_LIBRARY_DIRECTORY=${CMAKE_TEST_OUTPUT_DIRECTORY}"
            -D "TEST_FOLDER=${HDF4_JAVA_Examples_BINARY_DIR}"
            -D "TEST_OUTPUT=${resultfile}.out"
            -D "TEST_EXPECT=${resultcode}"
            -D "TEST_REFERENCE=${resultfile}.txt"
            -P "${HDF_RESOURCES_DIR}/jrunTest.cmake"
    )
    if (NOT "${last_test}" STREQUAL "")
      set_tests_properties (JAVAEX-${resultfile} PROPERTIES DEPENDS ${last_test})
    endif ()
    set (last_test "JAVAEX-${resultfile}")
  endmacro ()

  foreach (example ${HDFJNI_EXAMPLES})
    add_test (
        NAME JAVAEX-${example}-clearall-objects
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            ${HDF4_JAVA_Examples_BINARY_DIR}/${example}.hdf
            ${example}.out
            ${example}.out.err
    )
    if (NOT "${last_test}" STREQUAL "")
      set_tests_properties (JAVAEX-${example}-clearall-objects PROPERTIES DEPENDS ${last_test})
    endif ()
    set (last_test "JAVAEX-${example}-clearall-objects")
    ADD_H4_TEST (${example} 0)
  endforeach ()
endif ()

=== java/src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_JAVA_SRC C)

#-----------------------------------------------------------------------------
# Traverse source subdirectory
#-----------------------------------------------------------------------------
add_subdirectory (jni)
add_subdirectory (hdf)

=== mfhdf/dumper/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_MFHDF_DUMPER)

set (hdp_SRCS
    ${HDF4_MFHDF_DUMPER_SOURCE_DIR}/hdp.c
    ${HDF4_MFHDF_DUMPER_SOURCE_DIR}/hdp_dump.c
    ${HDF4_MFHDF_DUMPER_SOURCE_DIR}/hdp_gr.c
    ${HDF4_MFHDF_DUMPER_SOURCE_DIR}/hdp_list.c
    ${HDF4_MFHDF_DUMPER_SOURCE_DIR}/hdp_rig.c
    ${HDF4_MFHDF_DUMPER_SOURCE_DIR}/hdp_sds.c
    ${HDF4_MFHDF_DUMPER_SOURCE_DIR}/hdp_util.c
    ${HDF4_MFHDF_DUMPER_SOURCE_DIR}/hdp_vd.c
    ${HDF4_MFHDF_DUMPER_SOURCE_DIR}/hdp_vg.c
    ${HDF4_MFHDF_DUMPER_SOURCE_DIR}/show.c
)

if (NOT ONLY_SHARED_LIBS)
  add_executable (hdp ${hdp_SRCS})
  target_include_directories(hdp PRIVATE "${HDF4_HDFSOURCE_DIR};${HDF4_MFHDFSOURCE_DIR};$<$<BOOL:${HDF4_BUILD_XDR_LIB}>:${HDF4_MFHDF_XDR_DIR}>")
  TARGET_C_PROPERTIES (hdp STATIC)
  target_link_libraries (hdp PRIVATE ${HDF4_MF_LIB_TARGET})
  set_target_properties (hdp PROPERTIES COMPILE_DEFINITIONS "HDF")
  set_global_variable (HDF4_UTILS_TO_EXPORT "${HDF4_UTILS_TO_EXPORT};hdp")
  set (H4_DEP_EXECUTABLES hdp)
endif ()

if (BUILD_SHARED_LIBS)
  add_executable (hdp-shared ${hdp_SRCS})
  target_include_directories(hdp-shared PRIVATE "${HDF4_HDFSOURCE_DIR};${HDF4_MFHDFSOURCE_DIR};$<$<BOOL:${HDF4_BUILD_XDR_LIB}>:${HDF4_MFHDF_XDR_DIR}>")
  TARGET_C_PROPERTIES (hdp-shared SHARED)
  target_link_libraries (hdp-shared PRIVATE ${HDF4_MF_LIBSH_TARGET})
  set_target_properties (hdp-shared PROPERTIES COMPILE_DEFINITIONS "HDF")
  set_global_variable (HDF4_UTILS_TO_EXPORT "${HDF4_UTILS_TO_EXPORT};hdp-shared")
  set (H4_DEP_EXECUTABLES ${H4_DEP_EXECUTABLES} hdp-shared)
endif ()

if (BUILD_TESTING)
  include (CMakeTests.cmake)
endif ()

##############################################################################
##############################################################################
###           I N S T A L L A T I O N                                      ###
##############################################################################
##############################################################################

#-----------------------------------------------------------------------------
# Rules for Installation of tools using make Install target
#-----------------------------------------------------------------------------

foreach (exec ${H4_DEP_EXECUTABLES})
  INSTALL_PROGRAM_PDB (${exec} ${HDF4_INSTALL_TOOLS_BIN_DIR} toolsapplications)
endforeach ()

install (
    TARGETS
        ${H4_DEP_EXECUTABLES}
    EXPORT
        ${HDF4_EXPORTED_TARGETS}
    RUNTIME DESTINATION ${HDF4_INSTALL_TOOLS_BIN_DIR} COMPONENT toolsapplications
)

=== mfhdf/hdfimport/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_MFHDF_HDFIMPORT)

if (WIN32)
  set (CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:LIBCMT")
endif ()

set (hdfimport_SRCS
    ${HDF4_MFHDF_HDFIMPORT_SOURCE_DIR}/hdfimport.c
)

if (NOT ONLY_SHARED_LIBS)
  add_executable (hdfimport ${hdfimport_SRCS})
  target_include_directories(hdfimport PRIVATE "${HDF4_HDFSOURCE_DIR};${HDF4_MFHDFSOURCE_DIR};$<$<BOOL:${HDF4_BUILD_XDR_LIB}>:${HDF4_MFHDF_XDR_DIR}>")
  TARGET_C_PROPERTIES (hdfimport STATIC)
  target_link_libraries (hdfimport PRIVATE ${HDF4_MF_LIB_TARGET})
  set_target_properties (hdfimport PROPERTIES COMPILE_DEFINITIONS "HDF")
  set_global_variable (HDF4_UTILS_TO_EXPORT "${HDF4_UTILS_TO_EXPORT};hdfimport")

  set (H4_DEP_EXECUTABLES hdfimport)
endif ()

if (BUILD_SHARED_LIBS)
  add_executable (hdfimport-shared ${hdfimport_SRCS})
  target_include_directories(hdfimport-shared PRIVATE "${HDF4_HDFSOURCE_DIR};${HDF4_MFHDFSOURCE_DIR};$<$<BOOL:${HDF4_BUILD_XDR_LIB}>:${HDF4_MFHDF_XDR_DIR}>")
  TARGET_C_PROPERTIES (hdfimport-shared SHARED)
  target_link_libraries (hdfimport-shared PRIVATE ${HDF4_MF_LIBSH_TARGET})
  set_target_properties (hdfimport-shared PROPERTIES COMPILE_DEFINITIONS "HDF")
  set_global_variable (HDF4_UTILS_TO_EXPORT "${HDF4_UTILS_TO_EXPORT};hdfimport-shared")

  set (H4_DEP_EXECUTABLES ${H4_DEP_EXECUTABLES} hdfimport-shared)
endif ()

if (BUILD_TESTING)
  include (CMakeTests.cmake)
endif ()

##############################################################################
##############################################################################
###           I N S T A L L A T I O N                                      ###
##############################################################################
##############################################################################

#-----------------------------------------------------------------------------
# Rules for Installation of tools using make Install target
#-----------------------------------------------------------------------------

foreach (exec ${H4_DEP_EXECUTABLES})
  INSTALL_PROGRAM_PDB (${exec} ${HDF4_INSTALL_TOOLS_BIN_DIR} toolsapplications)
endforeach ()

install (
    TARGETS
        ${H4_DEP_EXECUTABLES}
    EXPORT
        ${HDF4_EXPORTED_TARGETS}
    RUNTIME DESTINATION ${HDF4_INSTALL_TOOLS_BIN_DIR} COMPONENT toolsapplications
)

=== mfhdf/hdiff/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_MFHDF_HDIFF)

if (WIN32)
  set (CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:LIBCMT")
endif ()

set (hdiff_SRCS
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_array.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_gr.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_list.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_main.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_mattbl.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_gattr.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_misc.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_sds.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_table.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_vs.c
    ${HDF4_MFHDF_HDIFF_SOURCE_DIR}/hdiff_dim.c
    ${HDF4_MFHDF_UTIL_DIR}/h4getopt.c
)

if (NOT ONLY_SHARED_LIBS)
  add_executable(hdiff ${hdiff_SRCS})
  target_include_directories(hdiff PRIVATE "${HDF4_HDFSOURCE_DIR};${HDF4_MFHDFSOURCE_DIR};${HDF4_MFHDF_UTIL_DIR};$<$<BOOL:${HDF4_BUILD_XDR_LIB}>:${HDF4_MFHDF_XDR_DIR}>")
  TARGET_C_PROPERTIES (hdiff STATIC)
  target_link_libraries(hdiff PRIVATE ${HDF4_MF_LIB_TARGET} ${HDF4_SRC_LIB_TARGET} ${LINK_LIBS})
  set_global_variable (HDF4_UTILS_TO_EXPORT "${HDF4_UTILS_TO_EXPORT};hdiff")

  set (H4_DEP_EXECUTABLES hdiff)
endif ()

if (BUILD_SHARED_LIBS)
  add_executable(hdiff-shared ${hdiff_SRCS})
  target_include_directories(hdiff-shared PRIVATE "${HDF4_HDFSOURCE_DIR};${HDF4_MFHDFSOURCE_DIR};${HDF4_MFHDF_UTIL_DIR};$<$<BOOL:${HDF4_BUILD_XDR_LIB}>:${HDF4_MFHDF_XDR_DIR}>")
  TARGET_C_PROPERTIES (hdiff-shared SHARED)
  target_link_libraries(hdiff-shared PRIVATE ${HDF4_MF_LIBSH_TARGET} ${HDF4_SRC_LIBSH_TARGET} ${LINK_LIBS})
  set_global_variable (HDF4_UTILS_TO_EXPORT "${HDF4_UTILS_TO_EXPORT};hdiff-shared")

  set (H4_DEP_EXECUTABLES ${H4_DEP_EXECUTABLES} hdiff-shared)
endif ()

if (BUILD_TESTING)
  include (CMakeTests.cmake)
endif ()

##############################################################################
##############################################################################
###           I N S T A L L A T I O N                                      ###
##############################################################################
##############################################################################

#-----------------------------------------------------------------------------
# Rules for Installation of tools using make Install target
#-----------------------------------------------------------------------------

foreach (exec ${H4_DEP_EXECUTABLES})
  INSTALL_PROGRAM_PDB (${exec} ${HDF4_INSTALL_TOOLS_BIN_DIR} toolsapplications)
endforeach ()

install (
    TARGETS
        ${H4_DEP_EXECUTABLES}
    EXPORT
        ${HDF4_EXPORTED_TARGETS}
    RUNTIME DESTINATION ${HDF4_INSTALL_TOOLS_BIN_DIR} COMPONENT toolsapplications
)

=== mfhdf/hrepack/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_MFHDF_HREPACK)

#INCLUDE_DIRECTORIES (${HDF4_SOURCE_DIR}/mfhdf/hdiff)

set (hrepack_SRCS
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_an.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_gr.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_list.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_lsttable.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_main.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_opttable.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_parse.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_sds.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_utils.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_vg.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_vs.c
    ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_dim.c
)

if (NOT ONLY_SHARED_LIBS)
  add_executable (hrepack ${hrepack_SRCS})
  target_include_directories(hrepack PRIVATE "${HDF4_HDFSOURCE_DIR};${HDF4_MFHDFSOURCE_DIR};$<$<BOOL:${HDF4_BUILD_XDR_LIB}>:${HDF4_MFHDF_XDR_DIR}>")
  TARGET_C_PROPERTIES (hrepack STATIC)
  target_link_libraries (hrepack PRIVATE ${HDF4_MF_LIB_TARGET} ${LINK_COMP_LIBS})
  set_target_properties (hrepack PROPERTIES COMPILE_DEFINITIONS "HDF")
  set_global_variable (HDF4_UTILS_TO_EXPORT "${HDF4_UTILS_TO_EXPORT};hrepack")

  add_executable (hrepack_check ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_check.c)
  target_include_directories(hrepack_check PRIVATE "${HDF4_HDFSOURCE_DIR};${HDF4_MFHDFSOURCE_DIR};$<$<BOOL:${HDF4_BUILD_XDR_LIB}>:${HDF4_MFHDF_XDR_DIR}>")
  TARGET_C_PROPERTIES (hrepack_check STATIC)
  target_link_libraries (hrepack_check PRIVATE ${HDF4_MF_LIB_TARGET})
  set_target_properties (hrepack_check PROPERTIES COMPILE_DEFINITIONS "HDF")

  set (H4_DEP_EXECUTABLES hrepack)
endif ()

if (BUILD_SHARED_LIBS)
  add_executable (hrepack-shared ${hrepack_SRCS})
  target_include_directories(hrepack-shared PRIVATE "${HDF4_HDFSOURCE_DIR};${HDF4_MFHDFSOURCE_DIR};$<$<BOOL:${HDF4_BUILD_XDR_LIB}>:${HDF4_MFHDF_XDR_DIR}>")
  TARGET_C_PROPERTIES (hrepack-shared SHARED)
  target_link_libraries (hrepack-shared PRIVATE ${HDF4_MF_LIBSH_TARGET} ${LINK_COMP_LIBS})
  set_target_properties (hrepack-shared PROPERTIES COMPILE_DEFINITIONS "HDF")
  set_global_variable (HDF4_UTILS_TO_EXPORT "${HDF4_UTILS_TO_EXPORT};hrepack-shared")

  add_executable (hrepack_check-shared ${HDF4_MFHDF_HREPACK_SOURCE_DIR}/hrepack_check.c)
  target_include_directories(hrepack_check-shared PRIVATE "${HDF4_HDFSOURCE_DIR};${HDF4_MFHDFSOURCE_DIR};$<$<BOOL:${HDF4_BUILD_XDR_LIB}>:${HDF4_MFHDF_XDR_DIR}>")
  TARGET_C_PROPERTIES (hrepack_check-shared SHARED)
  target_link_libraries (hrepack_check-shared PRIVATE ${HDF4_MF_LIBSH_TARGET})
  set_target_properties (hrepack_check-shared PROPERTIES COMPILE_DEFINITIONS "HDF")

  set (H4_DEP_EXECUTABLES ${H4_DEP_EXECUTABLES} hrepack-shared)
endif ()

if (BUILD_TESTING)
  include (CMakeTests.cmake)
endif ()

##############################################################################
##############################################################################
###           I N S T A L L A T I O N                                      ###
##############################################################################
##############################################################################

#-----------------------------------------------------------------------------
# Rules for Installation of tools using make Install target
#-----------------------------------------------------------------------------

foreach (exec ${H4_DEP_EXECUTABLES})
  INSTALL_PROGRAM_PDB (${exec} ${HDF4_INSTALL_TOOLS_BIN_DIR} toolsapplications)
endforeach ()

install (
    TARGETS
        ${H4_DEP_EXECUTABLES}
    EXPORT
        ${HDF4_EXPORTED_TARGETS}
    RUNTIME DESTINATION ${HDF4_INSTALL_TOOLS_BIN_DIR} COMPONENT toolsapplications
)

=== debian/changelog ===
libhdf4 (4.2.16-4build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:02:19 +0000

libhdf4 (4.2.16-4) unstable; urgency=medium

  * Team upload.
  * Use execute_{before,after} instead of override in rules file.
  * Enable Salsa CI.
  * Apply Multi-Arch patch by Yuriy M. Kaminskiy.
    (closes: #1063999)
  * Add libtirpc-dev to build dependencies.
    (closes: #1065290)

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 02 Mar 2024 12:50:52 +0100

libhdf4 (4.2.16-3) unstable; urgency=medium

  * Team upload.
  * Fix dfi.h by reinstating APOLLO #ifdef.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 13 Jun 2023 22:44:59 +0200

libhdf4 (4.2.16-2) unstable; urgency=medium

  * Team upload.
  * Bump debhelper compat to 13.
  * Add patch to fix dfi.h include.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 13 Jun 2023 20:53:51 +0200

libhdf4 (4.2.16-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 11 Jun 2023 13:26:43 +0200

libhdf4 (4.2.16-1~exp2) experimental; urgency=medium

  * Team upload.
  * Ignore test failures on ppc64el.
  * Don't hardcode RELEASE in rules.
  * Restore kfreebsd patch to fix 'unknown host' configure error.
  * Update upstream metadata for GitHub repo.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 09 Mar 2023 20:21:38 +0100

libhdf4 (4.2.16-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    (closes: #1025745)
  * Bump Standards-Version to 4.6.2, no changes.
  * Update copyright file.
  * Refresh patches.
  * Update symbols for 4.2.16.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 08 Mar 2023 18:47:19 +0100

=== debian/control ===
Source: libhdf4
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Johan Van de Wauw <johan@gisky.be>
Section: graphics
Priority: optional
Build-Depends: bison,
               chrpath,
               debhelper-compat (= 13),
               flex,
               gfortran,
               libaec-dev,
               libjpeg-dev,
               libtirpc-dev,
               sharutils,
               zlib1g-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian-gis-team/hdf4
Vcs-Git: https://salsa.debian.org/debian-gis-team/hdf4.git
Homepage: http://www.hdfgroup.com/
Rules-Requires-Root: no

Package: libhdf4-0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: libhdf4-doc,
          libhdf4-dev,
          hdf4-tools
Description: Hierarchical Data Format library (embedded NetCDF)
 HDF is a multi-object file format for storing and transferring
 graphical and numerical data mainly used in scientific computing. HDF
 supports several different data models, including multidimensional
 arrays, raster images, and tables. Each defines a specific aggregate
 data type and provides an API for reading, writing, and organizing the
 data and metadata. New data models can be added by the HDF developers
 or users.
 .
 This package contains the HDF run-time libraries.

Package: libhdf4-dev
Architecture: any
Section: libdevel
Depends: libhdf4-0 (= ${binary:Version}),
         libjpeg-dev,
         zlib1g-dev,
         ${misc:Depends}
Breaks: libhdf4g-dev (<< 4.2r4-1)
Conflicts: libhdf4-alt-dev
Replaces: libhdf4g-dev (<< 4.2r4-1)
Description: Hierarchical Data Format development files (embedded NetCDF)
 HDF is a multi-object file format for storing and transferring
 graphical and numerical data mainly used in scientific computing. HDF
 supports several different data models, including multidimensional
 arrays, raster images, and tables.
 Each defines a specific aggregate data type and provides an API for
 reading, writing, and organizing the data and metadata. New data models
 can be added by the HDF developers or users.
 .
 This package contains development stuff, including files and static
 library for the HDF package and some HDF API reference manpages.

Package: libhdf4-0-alt
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: libhdf4-doc,
          libhdf4-alt-dev,
          hdf4-tools
Description: Hierarchical Data Format library (without NetCDF)
 HDF is a multi-object file format for storing and transferring
 graphical and numerical data mainly used in scientific computing. HDF
 supports several different data models, including multidimensional
 arrays, raster images, and tables. Each defines a specific aggregate
 data type and provides an API for reading, writing, and organizing the
 data and metadata. New data models can be added by the HDF developers
 or users.
 .
 This package contains the HDF run-time libraries which do not
 collide with the NetCDF library namespace. Fortran functions
 are missing in this flavor of the library set.

Package: libhdf4-alt-dev
Architecture: any
Section: libdevel
Depends: libhdf4-0-alt (= ${binary:Version}),
         libjpeg-dev,
         libnetcdf-dev,
         zlib1g-dev,
         ${misc:Depends}
Breaks: libhdf4g-dev (<< 4.2r4-1)
Conflicts: libhdf4-dev
Replaces: libhdf4g-dev (<< 4.2r4-1)
Description: Hierarchical Data Format development files (without NetCDF)
 HDF is a multi-object file format for storing and transferring
 graphical and numerical data mainly used in scientific computing. HDF
 supports several different data models, including multidimensional
 arrays, raster images, and tables.
 Each defines a specific aggregate data type and provides an API for
 reading, writing, and organizing the data and metadata. New data models
 can be added by the HDF developers or users.
 .
 This package contains development stuff, including files and static
 library for the HDF package in the flavor compatible with the
 NetCDF library.

Package: libhdf4-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libhdf4-dev
Breaks: libhdf4g-doc (<< 4.2r4-1)
Provides: libhdf4g-doc
Replaces: libhdf4g-doc (<< 4.2r4-1)
Description: Hierarchical Data Format library -- documentation
 HDF  is  a  multi-object  file  format  for  storing  and  transferring
 graphical  and  numerical data mainly used in scientific computing.
 HDF  supports  several different  data models, including  multidimensional
 arrays, raster images,  and tables.
 Each defines  a specific aggregate  data type  and provides an  API for
 reading, writing, and organizing the data and metadata. New data models
 can be added by the HDF developers or users.
 .
 This package contains user guide and reference manual for HDF format
 and API

Package: hdf4-tools
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Hierarchical Data Format library -- runtime package
 HDF is a multi-object file format for storing and transferring
 graphical and numerical data mainly used in scientific computing. HDF
 supports several different data models, including multidimensional
 arrays, raster images, and tables.
 Each defines a specific aggregate data type and provides an API for
 reading, writing, and organizing the data and metadata. New data models
 can be added by the HDF developers or users.
 .
 This package includes some basic utilities to view, pack, unpack,
 HDF files.

=== debian/rules ===
#!/usr/bin/make -f
#
# Copyright (C) 2008 Francesco Paolo Lovergine <frankie@debian.org>
# Released under GPL. See /usr/share/common-licenses/GPL for
# more information about the license.
#

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

RELEASE := $(UPSTREAM_VERSION)
PACKAGE := libhdf4
SOVER   := 0

DESTDIR     := $(CURDIR)/debian/tmp
DESTDIR_ALT := $(CURDIR)/debian/tmp-alt

F77  := gfortran
CC   := gcc
CXX  := g++
LIBS := -ljpeg -lz -lm

export DEB_FFLAGS_MAINT_APPEND += -fallow-argument-mismatch
export DEB_CPPFLAGS_MAINT_APPEND = -I/usr/include/tirpc/
export DEB_LDFLAGS_MAINT_APPEND = -ltirpc

CFLAGS  = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get CFLAGS)
CFLAGS += $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get CPPFLAGS)
LDFLAGS = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get LDFLAGS)

ifneq (,$(findstring verbose,$(DEB_BUILD_OPTIONS)))
   DH_VERBOSE=1
   export DH_VERBOSE
endif

TEMPLATES=$(wildcard debian/*.in)

templates:
	for TEMPLATE in $(TEMPLATES) ; do \
		sed -e 's/@PACKAGE@/$(PACKAGE)/g' \
		    -e 's/@SOVER@/$(SOVER)/g' \
		    -e 's/@RELEASE@/$(RELEASE)/g' \
			$$TEMPLATE > `echo $$TEMPLATE | sed 's/.in$$//'` ; \
	done

%:
	dh $@

execute_before_dh_clean:
	$(RM) -r HDF$(RELEASE) HDF4 HDF4_ALT $(DESTDIR_ALT)

override_dh_auto_clean:
	if [ -e HDF4 ]; then \
		dh_auto_clean --sourcedirectory=HDF4 \
		              --builddirectory=debian/build-hdf4 ; \
	fi

	if [ -e HDF4_ALT ]; then \
		dh_auto_clean --sourcedirectory=HDF4_ALT \
		              --builddirectory=debian/build-hdf4-alt ; \
	fi

override_dh_autoreconf:
	mkdir HDF$(RELEASE)
	bash debian/copysources.sh $(RELEASE)
	patch <debian/rename_hdf_hdfalt -p1

	dh_autoreconf

override_dh_auto_configure: templates
	rm -rf HDF4 && ln -sf HDF$(RELEASE) HDF4

	# configure the 'regular' netcdf-clashing flavor.
	dh_auto_configure --sourcedirectory=HDF4 \
	                  --builddirectory=debian/build-hdf4 \
	                  -- --prefix=/usr \
	                     --includedir=/usr/include/hdf \
	                     --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	                     --enable-shared \
	                     --enable-fortran \
	                     --with-szlib=yes \
	                     F77="$(F77)" CC="$(CC)" CXX="$(CXX)" \
	                     CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

	# configure the netcdf compatible flavor, without fortran functions.
	dh_auto_configure --sourcedirectory=HDF4_ALT \
	                  --builddirectory=debian/build-hdf4-alt \
	                  -- --prefix=/usr \
	                     --includedir=/usr/include/hdf \
	                     --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	                     --enable-shared \
	                     --disable-fortran \
	                     --disable-netcdf \
	                     --with-szlib=yes \
	                     CC="$(CC)" CXX="$(CXX)" \
	                     CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

override_dh_auto_build:
	TESTS_ENVIRONMENT="LD_LIBRARY_PATH=$(CURDIR)/HDF4/hdf/src:$(CURDIR)/HDF4/mfhdf/libsrc:/usr/lib" \
		dh_auto_build --sourcedirectory=HDF4 \
		              --builddirectory=debian/build-hdf4 \
		              -- F77="$(F77)" CC="$(CC)" CXX="$(CXX)" \
		                 CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		                 LIBS="$(LIBS)"

	TESTS_ENVIRONMENT="LD_LIBRARY_PATH=$(CURDIR)/HDF4_ALT/hdf/src:$(CURDIR)/HDF4_ALT/mfhdf/libsrc:/usr/lib" \
		dh_auto_build --sourcedirectory=HDF4_ALT \
		              --builddirectory=debian/build-hdf4-alt \
		              -- CC="$(CC)" CXX="$(CXX)" \
		                 CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		                 LIBS="$(LIBS)"

override_dh_auto_test:
ifneq (,$(filter $(DEB_BUILD_ARCH),ppc64el s390x sparc64))
	dh_auto_test --sourcedirectory=HDF4 \
	             --builddirectory=debian/build-hdf4 \
	             --no-parallel \
	             -- F77="$(F77)" CC="$(CC)" CXX="$(CXX)" \
	                CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	                LIBS="$(LIBS)" \
	             || echo "Ignoring test failures"

	dh_auto_test --sourcedirectory=HDF4_ALT \
	             --builddirectory=debian/build-hdf4-alt \
	             --no-parallel \
	             -- CC="$(CC)" CXX="$(CXX)" \
	                CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	                LIBS="$(LIBS)" \
	             || echo "Ignoring test failures"
else
	dh_auto_test --sourcedirectory=HDF4 \
	             --builddirectory=debian/build-hdf4 \
	             --no-parallel \
	             -- F77="$(F77)" CC="$(CC)" CXX="$(CXX)" \
	                CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	                LIBS="$(LIBS)"

	dh_auto_test --sourcedirectory=HDF4_ALT \
	             --builddirectory=debian/build-hdf4-alt \
	             --no-parallel \
	             -- CC="$(CC)" CXX="$(CXX)" \
	                CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	                LIBS="$(LIBS)"
endif

override_dh_auto_install:
	dh_auto_install --sourcedirectory=HDF4 \
	                --builddirectory=debian/build-hdf4 \
	                --destdir=$(DESTDIR)

	dh_auto_install --sourcedirectory=HDF4_ALT \
	                --builddirectory=debian/build-hdf4-alt \
	                --destdir=$(DESTDIR_ALT)

	install -d $(DESTDIR)/usr/share/doc/$(PACKAGE)

	mkdir -p $(DESTDIR)/usr/share/man/man3
	sed -e "s/^\.TH HDF 1/\.TH HDF 3/" $(DESTDIR)/usr/share/man/man1/hdf.1 > $(DESTDIR)/usr/share/man/man3/hdf.3
	rm -f $(DESTDIR)/usr/share/man/man1/hdf.1 $(DESTDIR_ALT)/usr/share/man/man1/hdf.1
	
	mv $(DESTDIR_ALT)/usr/lib $(DESTDIR)/usr/lib-alt
	mv $(DESTDIR_ALT)/usr/include $(DESTDIR)/usr/include-alt

	# Move examples to -doc package
	mkdir -p $(DESTDIR)/usr/share/doc/$(PACKAGE)-doc
	mv $(DESTDIR)/usr/share/hdf4_examples $(DESTDIR)/usr/share/doc/$(PACKAGE)-doc/examples
	
	# strip rpath into binaries and libraries	
	for obj in $(DESTDIR)/usr/bin/* $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/*.so.* $(DESTDIR)/usr/lib-alt/$(DEB_HOST_MULTIARCH)/*.so.*; do \
		chrpath -d $${obj} || true; \
	done

	# Empty out the dependency field in our .la files
	for file in $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/*.la $(DESTDIR)/usr/lib-alt/$(DEB_HOST_MULTIARCH)/*.la; do \
		sed -i -e "/dependency_libs/ s/'.*'/''/" $$file ; \
	done

	# rename programs also provided by netcdf-bin
	mv $(DESTDIR)/usr/bin/ncdump $(DESTDIR)/usr/bin/ncdump-hdf
	mv $(DESTDIR)/usr/bin/ncgen $(DESTDIR)/usr/bin/ncgen-hdf

	# rename manuals also provided by netcdf-bin
	mv $(DESTDIR)/usr/share/man/man1/ncdump.1 $(DESTDIR)/usr/share/man/man1/ncdump-hdf.1
	sed -i -e 's/ncdump/ncdump-hdf/g' $(DESTDIR)/usr/share/man/man1/ncdump-hdf.1

	mv $(DESTDIR)/usr/share/man/man1/ncgen.1 $(DESTDIR)/usr/share/man/man1/ncgen-hdf.1
	sed -i -e 's/ncgen/ncgen-hdf/g' $(DESTDIR)/usr/share/man/man1/ncgen-hdf.1

override_dh_install:
	dh_install --sourcedir=$(DESTDIR)

	$(RM) -r $(CURDIR)/debian/tmp

execute_after_dh_installman:
	$(RM) $(CURDIR)/debian/hdf4-tools/usr/share/man/man1/hdf.1

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION)

override_dh_shlibdeps:
	dh_shlibdeps -l$(DESTDIR)/usr/lib:$(DESTDIR)/usr/lib-alt

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/ \
https://support.hdfgroup.org/ftp/HDF/releases/(HDF4\.\d+\.\S+)/src/ \
(?:.*?/)?(?:rel|v|hdf)?[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
